#pragma once

#ifdef __cplusplus

#include "4DPluginAPI.h"

#if VERSIONWIN
//	#include <Windows.h>
//	#include <stdio.h>
	#include <malloc.h>
//	#include <string.h>
//	#include <Winuser.h>
#else
	#include <Carbon/Carbon.h>
#endif

#define kErr_MemError -108;

extern "C" {
#endif

// basis
void InitPlugin(void);
void DeinitPlugin(void);

// --- Convert
void IM_Open( PA_PluginParameters params );
void IM_OpenBlob( PA_PluginParameters params );
void IM_Save( PA_PluginParameters params );
void IM_SaveBlob( PA_PluginParameters params );
void IM_New(PA_PluginParameters params );
void IM_Clear(PA_PluginParameters params );
void IM_Copy( PA_PluginParameters params );
void IM_Create( PA_PluginParameters params );
void IM_GetLastError( PA_PluginParameters params);
void IM_GetImageProperty( PA_PluginParameters params);
void IM_SetImageProperty( PA_PluginParameters params);
void IM_ModifyImage( PA_PluginParameters params);
void IM_Draw( PA_PluginParameters params);
void IM_GetProfile( PA_PluginParameters params );
void IM_GetSupportedFormats(PA_PluginParameters params );

// helpers

long ValidateIMObject(long newImage);

#if VERSIONMAC
// NewPath		can be NULL		Encoding MacRoman
// newPathUTF8  can be NULL		Encoding UTF8
OSErr build_4DPath_2_PosixPath (char* Pfad , char *NewPath , UInt8 *newPathUTF8 , CFIndex buffSize  );
#endif

#ifdef __cplusplus
}
#endif